#define SVC_NAME "FARBCopy"
#define PIPE_NAME "\\\\.\\pipe\\"SVC_NAME

#define OPERATION_COPY   1
#define OPERATION_INFO   2
#define OPERATION_ASCII  2037411683 //"copy"

// OPERATION_COPY

#define FILETYPE_FILE     1
#define FILETYPE_FOLDER   2
#define FILETYPE_JUNCTION 4

#define FILETYPE_UNKNOWN  0x80000000

#define COPYFLAG_DELETE    0x10000000

#define COPYFLAG_OVERWRITE 0x08000000
#define COPYFLAG_APPEND    0x04000000
#define COPYFLAG_SKIP      0x02000000
#define COPYFLAG_REFRESH   0x01000000

#define COPYFLAG_MOVE      0x00800000
#define COPYFLAG_FAIL      0x00400000
#define COPYFLAG_ROSRC     0x00200000
#define COPYFLAG_RODST     0x00100000

#define COPYFLAG_STATISTIC 0x00080000
#define COPYFLAG_ACCESS    0x00040000

#define STRFLAG_OVERWRITE 'o'
#define STRFLAG_APPEND    'a'
#define STRFLAG_REFRESH   'r'

#define STRFLAG_MOVE      'm'
#define STRFLAG_FAIL      'f'
#define STRFLAG_ROSRC     '1'
#define STRFLAG_RODST     '2'

#define STRFLAG_ACCESS    'u'

#define STRFLAG_STATISTIC '0'


struct FileRec
{
  DWORD type;
  wchar_t name[MAX_PATH];
};

struct FileRecs
{
  DWORD flags;
  DWORD count;
  struct FileRec *files;
};

struct StrRec
{
  DWORD flags;
  wchar_t from[MAX_PATH];
  wchar_t to[MAX_PATH];
};

// OPERATION_INFO

#define INFOTYPE_INVALID  0
#define INFOTYPE_COPY     1
#define INFOTYPE_MOVE     2
#define INFOTYPE_DELETE   3

#define INFOFLAG_ALL      0x00000001
#define INFOFLAG_BYHANDLE 0x00000002
#define INFOFLAG_STOP     0x00000004
#define INFOFLAG_PAUSE    0x00000008

struct SmallInfoRec
{
  DWORD ThreadId;
  DWORD type;
  wchar_t Src[MAX_PATH];
  BOOL InfoEx;
};

struct InfoRec
{
  struct SmallInfoRec info;
  wchar_t Src[MAX_PATH];
  wchar_t Dest[MAX_PATH];
  BOOL stop;
  BOOL pause;
// InfoEx
  SYSTEMTIME StartTime;
  unsigned long long TotalSize;
  unsigned long long CurrentSize;
  unsigned long long CurrentSizeAdd;
  unsigned long long Errors;
  unsigned long long PauseTime;
};
