struct InitDialogItem
{
  int Type;
  int X1, Y1, X2, Y2;
  int Focus;
  int Selected;
  unsigned int Flags;
  int DefaultButton;
  char *Data;
};

static void InitDialogItems(InitDialogItem *Init,FarDialogItem *Item,int ItemsNumber)
{
  for (int i=0;i<ItemsNumber;i++)
  {
    Item[i].Type=Init[i].Type;
    Item[i].X1=Init[i].X1;
    Item[i].Y1=Init[i].Y1;
    Item[i].X2=Init[i].X2;
    Item[i].Y2=Init[i].Y2;
    Item[i].Focus=Init[i].Focus;
    Item[i].Selected=Init[i].Selected;
    Item[i].Flags=Init[i].Flags;
    Item[i].DefaultButton=Init[i].DefaultButton;
    if ((unsigned)Init[i].Data<2000)
      strcpy(Item[i].Data,GetMsg((unsigned int)Init[i].Data));
    else
      strcpy(Item[i].Data,Init[i].Data);
  }
}

#include <winioctl.h>

static void ConvertJunction(wchar_t *From,wchar_t *To)
{
  HANDLE fileHandle;
  BYTE reparseBuffer[MAXIMUM_REPARSE_DATA_BUFFER_SIZE];
  PBYTE reparseData;
  PREPARSE_GUID_DATA_BUFFER reparseInfo=(PREPARSE_GUID_DATA_BUFFER)reparseBuffer;
  PREPARSE_DATA_BUFFER msReparseInfo=(PREPARSE_DATA_BUFFER)reparseBuffer;
  DWORD returnedLength;

  wcscpy(To,From);
  fileHandle=CreateFileW(From,0,FILE_SHARE_READ|FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_FLAG_BACKUP_SEMANTICS|FILE_FLAG_OPEN_REPARSE_POINT,0);
  if(fileHandle==INVALID_HANDLE_VALUE)
    return;
  if(GetFileAttributesW(From)&FILE_ATTRIBUTE_REPARSE_POINT) 
    if(DeviceIoControl(fileHandle,FSCTL_GET_REPARSE_POINT,NULL,0,reparseInfo,sizeof(reparseBuffer),&returnedLength,NULL))
      if(IsReparseTagMicrosoft(reparseInfo->ReparseTag)) 
        if(reparseInfo->ReparseTag==IO_REPARSE_TAG_MOUNT_POINT)
        {
          reparseData=(PBYTE)&msReparseInfo->MountPointReparseBuffer.PathBuffer;
          wcsncpy(To,(PWCHAR)(reparseData+msReparseInfo->MountPointReparseBuffer.SubstituteNameOffset+8),msReparseInfo->MountPointReparseBuffer.SubstituteNameLength-8);
          To[msReparseInfo->MountPointReparseBuffer.SubstituteNameLength-8]=0;
          wcscat(To,L"\\");
        }
  CloseHandle(fileHandle);
}

BOOL CheckPaths(wchar_t *Src,wchar_t *Dest,BOOL Trim)
{
  wchar_t rSrc[MAX_PATH],rDest[MAX_PATH];
  ConvertJunction(Src,rSrc);
  ConvertJunction(Dest,rDest);
  if(Trim)
    return !wcsnicmp(rSrc,rDest,wcslen(rSrc));
  else
    return !wcsicmp(rSrc,rDest);
}